export const others = {
	methods: {
		//富文本的回调
		navigate() {

		},
		moreClick() {
			this.$set(this.moreList[1], 'text', this.detail.collected ? '已收藏' : '收藏');
			this.is_more = true;
		},
		cancel() {
			this.is_more = false;
		}
	}
}

// 收藏
export const collection = {
	methods: {
		//收藏
		goCollectionCreate: async function(item, type) {
			let res = await this.$u.api.goCollectionCreate({
				id: item.id,
				type: type
			});
			this.$u.toast(res.msg);
			if (!res.code) {
				return;
			}
			if (type == 'article' || type == 'question' || type == 'answer') {
				item.collected = true;
			}
		},
		//取消收藏
		goCollectionDelete: async function(item, type) {
			let res = await this.$u.api.goCollectionDelete({
				id: item.id,
				type: type
			});
			this.$u.toast(res.msg);
			if (!res.code) {
				return;
			}
			if (type == 'article' || type == 'question' || type == 'answer') {
				item.collected = false;
			}
		},
	},
}
// 点赞
export const vote = {
	methods: {
		goVoteCreate: async function(item, type, value = 'up') {
			let res = await this.$u.api.goVoteCreate({
				id: item.id,
				type: type,
				value: value
			});
			this.$u.toast(res.msg);
			if (!res.code) {
				return;
			}
			item.vote = value;
			item.voteup = res.data.voteup;

		},
		goVoteDelete: async function(item, type, value = 'up') {
			let res = await this.$u.api.goVoteDelete({
				id: item.id,
				type: type,
				value: value
			})
			this.$u.toast(res.msg);
			if (!res.code) {
				return;
			}
			item.voteup = res.data.voteup;
			item.vote = '';
		},
	}
}
// 关注
export const attention = {
	methods: {
		goAttentionCreate: async function(item, type, callback) {
			let res = await this.$u.api.goAttentionCreate({
				id: item.id,
				type: type
			})
			this.$u.toast(res.msg);
			if (!res.code) {
				return;
			}
			item.followed = true;
			if (typeof callback == 'function') {
				callback();
			};
		},
		goAttentionDelete: async function(item, type, callback = () => {}) {
			let res = await this.$u.api.goAttentionDelete({
				id: item.id,
				type: type
			})
			this.$u.toast(res.msg);
			if (!res.code) {
				return;
			}
			item.followed = false;
			if (typeof callback == 'function') {
				callback();
			};
		},
	}
}
//轮播图
export const swipers = {
	methods: {
		//轮播图事件
		clickSwiper(index) {
			let path = this.vuex_config.blockList[index].url;
			if (path == '/' || !path) {
				return;
			}
			if (path.substr(0, 1) == 'p') {
				path = '/' + path;
			}
			this.$u.route({
				url: path
			})
		},
	}
}
//样式
export const styleRest = {
	methods: {
		getStyle(string) {
			let underline = {};
			let style = {};
			let s = string.split('|');
			s.forEach(item => {
				if (item == 'b') {
					style.fontWeight = 'bold';
				}
				if (item == 'u') {
					underline.textDecoration = 'underline';
				}
				if (item.indexOf('#') != -1) {
					let color = item.split(',');
					style.backgroundImage = `linear-gradient(90deg,${color[0]} 0%, ${color[1]?color[1]:color[0]} 100%)`;
					style.textFillColor = 'transparent'
				}
			})
			return [underline, style];
		},
		setStyle(item) {			
			if (item.style) {
				let result = this.getStyle(item.style);
				item.styleArray = result[1];
				item.underline = result[0];
			} else {
				item.styleArray = {};
				item.underline = {};
			}
		}
	}
}
//跳转标签
export const tagClick = {
	methods: {
		navigateTag(id, type) {
			this.$u.route(`/pages/tag/detail?id=${id}&type=${type}`)
		}
	}
}
//登录成功之后
export const login = {
	methods: {
		success: async function(id,index=1) {
			let res = await this.$u.api.getUserIndex({
				id: id
			});
			if (!res.code) {
				this.$u.toast(res.msg);
				return;
			}
			this.$u.vuex('vuex_user', res.data.user);
			this.$u.vuex('vuex_isAdmin', res.data.isAdmin);
			// #ifdef APP-PLUS
			this.$Router.back(index)
			// #endif
			// #ifndef APP-PLUS
			let value = uni.getStorageSync('last_page');
			//有上次页面，关闭所有页面，到此页面
			if (value) {
				this.$Router.replaceAll(Object.assign({},value))				
				return;
			}
			//默认到首页
			this.$Router.replaceAll({
				url: '/pages/index/index'
			});
			// #endif
		}
	}
}
// 查看品类模块(首页资料页)

export const getQuickTag = {
	data(){
		return {
			quickTab:{
				tabs:[],
				tags:[]
			}
		}
	},
	methods:{
		getTabTitle(){
			
		},
		getTabItem(){
			
		},
	}
}