module.exports = {
	computed: {
		theme() {
			if (this.vuex_config.theme) {				
				let theme = this.vuex_config.theme;
				let colorArr = this.$u.colorGradient(theme.bgColor, theme.color, theme.ladder);								
				return Object.assign({
					lightColor:colorArr[theme.number] || '#f5f5f5',
					faBorderColor:colorArr[theme.border] || '#f5f5f5'
				},theme);
			}
			return {
				bgColor: "#0301c5",
				border: 5,
				color: "#ffffff",
				ladder: 10,
				number: 9,
				lightColor:'#f5f5f5',
				faBorderColor:'#f5f5f5'
			};
		},	
		btnBgColor(vote, type) {
			return (vote, type) => {
				if(typeof type == 'undefined'){
					return vote ? this.theme.bgColor : this.theme.lightColor;
				}
				return vote == type ? this.theme.bgColor : this.theme.lightColor;
			};
		},
		btnColor(vote, type) {
			return (vote, type) => {
				if(typeof type == 'undefined'){
					return vote? this.theme.color : this.theme.bgColor;
				}
				return vote == type ? this.theme.color : this.theme.bgColor;
			};
		}
	},
}
