// import {codeApiFun}  from '@/common/api/code.js';
// import {datumApiFun}  from '@/common/api/datum.js';
import {apiFun}  from '@/common/api/index.js';
import {
	cloudRulesApiFun
} from "@/common/api/cloud_rules.js"
const upload = async function(path, params = {}, vm) {

	return new Promise((resolve, reject) => {
		uni.showLoading({
			mask: true,
			title: '上传中'
		});
		let data = {
			url: vm.vuex_config.upload.uploadurl,
			filePath: path,
			header: {
				token: vm.vuex_token || '',
				uid: vm.vuex_user.id || 0
			},
			name: 'file',
			fileType:'image',
			complete: function() {
				uni.hideLoading();
			},
			success: uploadFileRes => {
				try {
					var res = uploadFileRes.data;
					if (vm.$u.test.jsonString(res)) {
						resolve(JSON.parse(res).data)
					}
					if (vm.$u.test.object(res)) {
						resolve(res.data)
					}
				} catch (e) {
					reject(uploadFileRes.data);
				}
			},
			fail: (e) => {
				reject(e);
			}
		};
		let isObj = vm.$u.test.object(vm.vuex_config.upload.multipart);		
		if (isObj) {
			data.formData = vm.vuex_config.upload.multipart;
		}
		uni.uploadFile(data);
	})

}

const install = (Vue, vm) => {
	let apiUrls = apiFun(vm)
	// let getConfig 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.common/config', params);
	// let getEmsSend 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.ems/send', params);
	// let getSmsSend 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.sms/send', params);
	// let getSearchIndex    = async (params = {}) => await vm.$u.get('/addons/ask/api.search/index', params); //普通搜索
	// let getMyboutus 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.common/aboutus', params);
	// let getMyagree 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.common/agreement', params);
	// let getQuestionIndex  = async (params = {}) => await vm.$u.get('/addons/ask/api.question/index', params);
	// let getQuestionShow   = async (params = {}) => await vm.$u.get('/addons/ask/api.question/show', params);
	// let getQuestionClose  = async (params = {}) => await vm.$u.get('/addons/ask/api.question/close', params);
	// let getQuestionOpen   = async (params = {}) => await vm.$u.get('/addons/ask/api.question/open', params);
	// let getQuestionDelete = async (params = {}) => await vm.$u.get('/addons/ask/api.question/delete', params);
	// let getQuestionConfig = async (params = {}) => await vm.$u.get('/addons/ask/api.question/config', params);
	// let goQuestionConfig  = async (params = {}) => await vm.$u.post('/addons/ask/api.question/config', params);
	// let getQuestionReward = async (params = {}) => await vm.$u.post('/addons/ask/api.question/reward', params);
	// let getQuestionAdopt  = async (params = {}) => await vm.$u.post('/addons/ask/api.question/adopt', params);
	// let getQuestionPost   = async (params = {}) => await vm.$u.get('/addons/ask/api.question/post', params);
	// let goQuestionPost    = async (params = {}) => await vm.$u.post('/addons/ask/api.question/post', params);
	// let getQuestionUpdate = async (params = {}) => await vm.$u.get('/addons/ask/api.question/update', params);
	// let goQuestionUpdate  = async (params = {}) => await vm.$u.post('/addons/ask/api.question/update', params);
	// let goAnswerPost 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.answer/post', params);
	// let goAnswerDelete 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.answer/delete', params);
	// let getAnswerUpdate   = async (params = {}) => await vm.$u.get('/addons/ask/api.answer/update', params);
	// let goAnswerUpdate    = async (params = {}) => await vm.$u.post('/addons/ask/api.answer/update', params);
	// let getAnswerList     = async (params = {}) => await vm.$u.get('/addons/ask/api.ajax/get_answer_list', params);
	// let getCommentList    = async (params = {}) => await vm.$u.get('/addons/ask/api.ajax/get_comment_list', params);
	// let getQuestionList   = async (params = {}) => await vm.$u.get('/addons/ask/api.ajax/get_question_list', params);
	// let getArticleList    = async (params = {}) => await vm.$u.get('/addons/ask/api.ajax/get_article_list', params);
	// let getArticleIndex   = async (params = {}) => await vm.$u.get('/addons/ask/api.article/index', params);
	// let getArticleShow    = async (params = {}) => await vm.$u.get('/addons/ask/api.article/show', params);
	// let getArticleDelete  = async (params = {}) => await vm.$u.get('/addons/ask/api.article/delete', params);
	// let getArticleConfig  = async (params = {}) => await vm.$u.get('/addons/ask/api.article/config', params);
	// let goArticleConfig   = async (params = {}) => await vm.$u.post('/addons/ask/api.article/config', params);
	// let getArticlePost    = async (params = {}) => await vm.$u.get('/addons/ask/api.article/post', params);
	// let goArticlePost     = async (params = {}) => await vm.$u.post('/addons/ask/api.article/post', params);
	// let getArticleUpdate  = async (params = {}) => await vm.$u.get('/addons/ask/api.article/update', params);
	// let goArticleUpdate   = async (params = {}) => await vm.$u.post('/addons/ask/api.article/update', params);
	// let getZoneIndex 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.zone/index', params);
	// let getZoneShow 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.zone/show', params);
	// let getTagIndex 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.tag/index', params);
	// let getTagShow 	   	  = async (params = {}) => await vm.$u.get('/addons/ask/api.tag/show', params);
	// let getExpertIndex    = async (params = {}) => await vm.$u.get('/addons/ask/api.expert/index', params);
	// let getExpertCreate   = async (params = {}) => await vm.$u.post('/addons/ask/api.expert/create', params);
	// let getLogin 	  	  = async (params = {}) => await vm.$u.post('/addons/ask/api.login/login', params);
	// let mobilelogin 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.login/mobilelogin', params);
	// let getRegister 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.login/register', params);
	// let getResetpwd 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.login/resetpwd', params);
	// // let gowxLogin 	  	  = async (params = {}) => await vm.$u.post('/addons/ask/api.login/wxLogin', params);
	// let gowxLogin 	  	  = async (params = {}) => await vm.$u.post('/addons/cms/wxapp.login/wxa', params,{'content-type': 'application/x-www-form-urlencoded'});
	
	// let gowxBindPhone 	  = async (params = {}) => await vm.$u.post('/addons/cms/wxapp.login/login', params);
	// let goAppLogin 	  	  = async (params = {}) => await vm.$u.post('/addons/ask/api.login/appLogin', params);
	// let getMyinfo 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.user/myinfo', params);
	// let getUserIndex 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.user/index', params);
	// let getUserQuestion   = async (params = {}) => await vm.$u.get('/addons/ask/api.user/question', params);
	// let getUserAnswer     = async (params = {}) => await vm.$u.get('/addons/ask/api.user/answer', params);
	// let getUserArticle    = async (params = {}) => await vm.$u.get('/addons/ask/api.user/article', params);
	// let getUserFollower   = async (params = {}) => await vm.$u.get('/addons/ask/api.user/follower', params);
	// let getUserAttention  = async (params = {}) => await vm.$u.get('/addons/ask/api.user/attention', params);
	// let getUserCollection = async (params = {}) => await vm.$u.get('/addons/ask/api.user/collection', params);
	// let getUserNotification = async (params = {}) => await vm.$u.get('/addons/ask/api.user/notification', params);
	// let getUserMessage 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.user/message', params);
	// let getUserInvite     = async (params = {}) => await vm.$u.get('/addons/ask/api.user/invite', params);
	// let getUserProfile    = async (params = {}) => await vm.$u.post('/addons/ask/api.user/profile', params);
	// let getUserResetpwd   = async (params = {}) => await vm.$u.post('/addons/ask/api.user/resetpwd', params);
	// let getUserLogout     = async (params = {}) => await vm.$u.get('/addons/ask/api.user/logout', params);
	// let getMyTotal        = async (params = {}) => await vm.$u.get('/addons/ask/api.user/myTotal', params);
	// let goCommentPost 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.comment/post', params);
	// let goCommentUpdate   = async (params = {}) => await vm.$u.post('/addons/ask/api.comment/update', params);
	// let goCommentDelete   = async (params = {}) => await vm.$u.get('/addons/ask/api.comment/delete', params);
	// let goVoteCreate      = async (params = {}) => await vm.$u.post('/addons/ask/api.vote/create', params);
	// let goVoteDelete      = async (params = {}) => await vm.$u.post('/addons/ask/api.vote/delete', params);
	// let goAttentionCreate = async (params = {}) => await vm.$u.post('/addons/ask/api.attention/create', params);
	// let goAttentionDelete = async (params = {}) => await vm.$u.post('/addons/ask/api.attention/delete', params);
	// let goReportCreate    = async (params = {}) => await vm.$u.post('/addons/ask/api.report/create', params);
	// let goCollectionCreate= async (params = {}) => await vm.$u.post('/addons/ask/api.collection/create', params);
	// let goCollectionDelete= async (params = {}) => await vm.$u.post('/addons/ask/api.collection/delete', params);
	// let goInviteSearch 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.invite/search', params);
	// let goInvitePost 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.invite/post', params);
	// let goMessagePost 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.message/post', params);
	// let goThanksCreate 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.thanks/create', params);
	// let goOrderSubmit 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.order/submit', params);
	// let getMoneyLogs 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.the_logs/money', params);
	// let getScoreLogs 	  = async (params = {}) => await vm.$u.get('/addons/ask/api.the_logs/score', params);
	// let getRechargeConfig = async (params = {}) => await vm.$u.get('/addons/recharge/api.recharge/config', params);
	// let goRechargeSubmit  = async (params = {}) => await vm.$u.post('/addons/recharge/api.recharge/submit', params);
	// let getAuthUrl 	      = async (params = {}) => await vm.$u.get('/addons/third/api/getAuthUrl', params);
	// let goAuthCallback 	  = async (params = {}) => await vm.$u.post('/addons/third/api/callback', params);	
	// let goThirdAccount 	  = async (params = {}) => await vm.$u.post('/addons/third/api/account', params);
	// let goUpload 		  = async (path, params = {}) => await upload(path, params, vm);
	// let getHomeIndex 		  = async (params = {}) => await vm.$u.get('/addons/cms/wxapp.home/index', params);
	// let goSetWorkType 		  = async (params = {}) => await vm.$u.get('/addons/cms/wxapp.user/worker', params);
	// let getAskIndex 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.ask/index', params);
	// let getAskDeTail 		  = async (params = {}) => await vm.$u.get('/addons/ask/api.ask/show', params);
	// let goAskPost 		  = async (params = {}) => await vm.$u.post('/addons/ask/api.ask/post', params);
	// let goReplyPost 	  = async (params = {}) => await vm.$u.post('/addons/ask/api.reply/post', params);
	// let getReplyUpdate   = async (params = {}) => await vm.$u.get('/addons/ask/api.reply/update', params);
	// let goReplyUpdate    = async (params = {}) => await vm.$u.post('/addons/ask/api.reply/update', params);
	// let getQiniuToken    = async (params = {}) => await vm.$u.get('/addons/qiniu/index/createToken');
	// 将各个定义的接口名称，统一放进对象挂载到vm.$u.api(因为vm就是this，也即this.$u.api)下
	vm.$u.api = {
		...apiUrls,
		// getConfig,
		// getLogin,
		// getRegister,
		// getResetpwd,
		// gowxLogin,
		// gowxBindPhone,
		// goAppLogin,
		// mobilelogin,
		// getEmsSend,
		// getSmsSend,
		// getSearchIndex,
		// getMyboutus,
		// getMyagree,
		// getQuestionIndex,
		// getQuestionShow,
		// getQuestionClose,
		// getQuestionOpen,
		// getQuestionDelete,
		// getQuestionConfig,
		// goQuestionConfig,
		// getQuestionReward,
		// getQuestionAdopt,
		// getQuestionPost,
		// goQuestionPost,
		// getQuestionUpdate,
		// goQuestionUpdate,
		// getQuestionList,
		// getAnswerList,
		// goAnswerPost,
		// goAnswerDelete,
		// getAnswerUpdate,
		// goAnswerUpdate,
		// getArticleIndex,
		// getArticleShow,
		// getArticleDelete,
		// getArticleConfig,
		// goArticleConfig,
		// getArticlePost,
		// goArticlePost,
		// getArticleUpdate,
		// goArticleUpdate,
		// getArticleList,
		// getZoneIndex,
		// getZoneShow,
		// getTagIndex,
		// getTagShow,
		// getExpertIndex,
		// getExpertCreate,
		// getMyinfo,
		// getUserIndex,
		// getUserQuestion,
		// getUserAnswer,
		// getUserArticle,
		// getUserFollower,
		// getUserAttention,
		// getUserCollection,
		// getUserNotification,
		// getUserMessage,
		// getUserInvite,
		// getUserProfile,
		// getUserResetpwd,
		// getUserLogout,
		// getMyTotal,
		// goThirdAccount,
		// getAuthUrl,
		// goAuthCallback,
		// goCommentPost,
		// getCommentList,
		// goCommentUpdate,
		// goCommentDelete,
		// goVoteCreate,
		// goVoteDelete,
		// goAttentionCreate,
		// goAttentionDelete,
		// goReportCreate,
		// goCollectionCreate,
		// goCollectionDelete,
		// goInviteSearch,
		// goInvitePost,
		// goMessagePost,
		// goThanksCreate,
		// goOrderSubmit,
		// getRechargeConfig,
		// goRechargeSubmit,
		// getMoneyLogs,
		// getScoreLogs,
		// goUpload,
		// getHomeIndex,
		// goSetWorkType,
		// getAskIndex,
		// getAskDeTail,
		// goReplyPost,
		// getReplyUpdate,
		// goReplyUpdate,
		// goAskPost,
		// getQiniuToken
	};
	let cloudRules = cloudRulesApiFun(vm)
	vm.$u.cloudApi = {
		...cloudRules
	}
}

export default {
	install
}
